class Scale < Array
  def self.build(*arr)
    notes =
      arr.flat_map.with_index { |names, position|
        names.split("|").map { |name| Note.new(name, position) } }
    new(notes)
  end

  def [] idx
    return super(idx % size) if idx.is_a? Fixnum
    super(idx)
  end

  def find_note(name)
    find { |note| note.name == name }
  end
end

NATURALS = %w(A B C D E F G)

SHARPS_SCALE ||= begin
  scale_with_sharps = %w(A A# B C C# D D# E F F# G G#)
  Scale.build(*scale_with_sharps).freeze
end

FLATS_SCALE ||= begin
  scale_with_flats = %w(A Bb B C Db D Eb E F Gb G Ab)
  Scale.build(*scale_with_flats).freeze
end

JOIN_SCALE ||= begin
  sharps_and_flats = %w(A A#|Bb B C C#|Db D D#|Eb E F F#|Gb G G#|Ab)
  Scale.build(*sharps_and_flats).freeze
end
